c	Testing and adjusting bathymetry for MOST model usage
c	(c) Vasily Titov 1999

      program Bath_corr
      real*8 d(4500,4500)
      real*8 h1(4500), h2(4500), h11(4500), h22(4500)
      common /run/ t,n,npics
      data  mm,nn/4500,4500/
c  mm, nn should be exactly the size of the arrays as in "real" statement
      
      write (*,*) 'Max wave height estimate:'
      read (*,*) wvmax
      write (*,*) 'Minimum depth in computation:'
      read (*,*) grnd
      write (*,*) 'Steepness threshold:'
      read (*,*) steep
      write (*,*) 'Reading Bathymetry'
      npics=1
      offshr=5000.
      call BathRead(d,h11,h22,m,n,mm,nn,grnd)
      do i=1,m-1
         h1(i)=(h11(i+1)-h11(i))*111320.
         
      end do
      do i=1,n-1
         h2(i)=(h22(i+1)-h22(i))*111320.
      end do
      do i=1,m
         do j=1,n
            d(i,j)=d(i,j)+wvmax
         end do
      end do
c..... Bathymetry correction along X
      num=0
      write (*,*) 'Corrections along X'
      do i=2,m-1
        do j=1,n
          if (d(i,j).GT.grnd) then
            dp1=d(i+1,j)
            dm1=d(i-1,j)
            if(d(i+1,j).LT.grnd) dp1=grnd
            if(d(i-1,j).LT.grnd) dm1=grnd
            angle1=abs(d(i,j)-dm1)/sqrt(offshr*d(i,j))
            angle2=abs(d(i,j)-dp1)/sqrt(offshr*d(i,j))
            if(angle1+angle2.GT.steep)then
              num=num+1
              write (*,*) num,' point: i,j=',i,j
              write (*,*) 'Original :',d(i-1,j),d(i,j),d(i+1,j)
              d(i,j)=(dp1-dm1)**2/offshr/(steep*.5)**2
              if (d(i,j).GT.max(dp1,dm1).OR.
     &            d(i,j).LT.min(dp1,dm1))
     &            d(i,j)=0.5*(dp1+dm1)
              write (*,*) 'Corrected:',d(i-1,j),d(i,j),d(i+1,j)
            end if
          end if
        end do
      end do      
c..... Bathymetry correction along Y
      write (*,*) 'Corrections along Y'
      do j=1,m
        do i=2,n-1
          if (d(j,i).GT.grnd) then
            dp1=d(j,i+1)
            dm1=d(j,i-1)
            if(d(j,i+1).LT.grnd) dp1=grnd
            if(d(j,i-1).LT.grnd) dm1=grnd
            angle1=abs(d(j,i)-dm1)/sqrt(offshr*d(j,i))
            angle2=abs(d(j,i)-dp1)/sqrt(offshr*d(j,i))
            if(angle1+angle2.GT.steep) then
              num=num+1
              write (*,*) num,' point: i,j=',j,i
              write (*,*) 'Original :',d(j,i-1),d(j,i),d(j,i+1)
              d(j,i)=(dp1-dm1)**2/offshr/(steep*.5)**2
              if (d(j,i).GT.max(dp1,dm1).OR.
     &            d(j,i).LT.min(dp1,dm1))
     &            d(j,i)=0.5*(dp1+dm1)
              write (*,*) 'Corrected:',d(j,i-1),d(j,i),d(j,i+1)
            end if
          end if
        end do
      end do
      do i=1,m
         do j=1,n
            d(i,j)=d(i,j)-wvmax
         end do
      end do
      call ExWrite('Bat',d,h11,h22,m,n,mm,nn)
      tmax=60.
      do i=1,m-1
        do j=1,n-1
          if (d(i,j).GT.0) then
            tc1=h1(i)*COS(3.1415927/180.*h22(j))/sqrt(9.8*d(i,j))
            tc2=h2(j)/sqrt(9.8*d(i,j))
            tc=min(tc1,tc2)
            if (tc.LT.tmax)then
               tmax=tc
               imax=i
               jmax=j
            end if
          end if
        end do
      end do      
      write (*,*) 'Maximum dt=', tmax
      write (*,*) 'at depth',d(imax,jmax),'m; i,j=',imax,jmax
      end
      
      subroutine ExWrite(prfx,d,h1,h2,n1,n2,mm,nn)
c.....Write surface for Explorer visualization
      real*8 d(mm,nn),h1(mm),h2(nn)
      character*13 sname
      character*3 prfx
      common /run/ t,n,npics
      sname=prfx//'.corrected'
      write (*,*) 'Writing surface into file ', sname
      open (unit=1,file=sname,form='formatted')
      ns1=1
      ns2=1
      ne1=n1
      ne2=n2
      istep=npics
      jstep=npics
 10   format(F20.13)
      write (1,*) (ne1-ns1)/istep+1,(ne2-ns2)/jstep+1
      do i=ns1,ne1,istep
         write (1,10) h1(i)
      end do
      do j=ne2,ns2,-jstep
         write(1,10) h2(j)
      end do
          
 666  format (4500F12.4)
      do j=ne2,ns2,-jstep
         write(1,666) (d(i,j),i=ns1,ne1,istep)
      end do
      close(unit=1,status='keep')
      return
      end

      subroutine BathRead(d,h1,h2,n1,n2,m,n,grnd)
c.....Reads bathymetry data in MOST format,
c.....initializes variables and BC
      real*8 d(m,n),h1(m),h2(n)
      character*80 fname
      write(*,801)
 801  format(' Bathymetry filename: ',$)
      read(*,802) fname
 802  format(a)
      nc=index(fname,' ')
      fname(nc:nc)='\0'
      open(unit=1,file=fname,status='old'
     &     ,form='formatted')
      read (1,*) n1,n2
      read (1,*) (h1(i), i=1,n1)
      read (1,*) (h2(i), i=n2,1,-1)
      do i=1,n1
      	if (h1(i).LT.0.) h1(i)=360.+h1(i)
      end do
      do j=n2,1,-1
      	read (1,*) (d(i,j), i=1,n1)
      end do
      close(unit=1,status='keep')
c..... Eliminate one-node islands ........
      do i=2,n1-1
       do j=2,n2-1
         if(d(i,j).LE.grnd) then
           if(d(i+1,j).GT.grnd.AND.d(i-1,j).GT.grnd.OR.
     &        d(i,j+1).GT.grnd.AND.d(i,j-1).GT.grnd) then
             d1=(d(i,j)+d(i,j-1)+d(i+1,j-1)+d(i+1,j))*.25
             d2=(d(i,j)+d(i,j+1)+d(i+1,j+1)+d(i+1,j))*.25
             d3=(d(i,j)+d(i,j+1)+d(i-1,j+1)+d(i-1,j))*.25
             d4=(d(i,j)+d(i,j-1)+d(i-1,j-1)+d(i-1,j))*.25
             depthmin=MIN(d1,d2,d3,d4)
             if(d1.LE.depthmin)then
               if(d(i,j-1).GT.grnd) d(i,j-1)=grnd-.5
               if(d(i+1,j-1).GT.grnd) d(i+1,j-1)=grnd-.5
               if(d(i+1,j).GT.grnd) d(i+1,j)=grnd-.5
             else if(d2.LE.depthmin)then
               if(d(i,j+1).GT.grnd) d(i,j+1)=grnd-.5
               if(d(i+1,j+1).GT.grnd) d(i+1,j+1)=grnd-.5
               if(d(i+1,j).GT.grnd) d(i+1,j)=grnd-.5
             else if(d3.LE.depthmin)then
               if(d(i,j+1).GT.grnd) d(i,j+1)=grnd-.5
               if(d(i-1,j+1).GT.grnd) d(i-1,j+1)=grnd-.5
               if(d(i-1,j).GT.grnd) d(i-1,j)=grnd-.5
             else if(d4.LE.depthmin)then
               if(d(i,j-1).GT.grnd) d(i,j-1)=grnd-.5
               if(d(i-1,j-1).GT.grnd) d(i-1,j-1)=grnd-.5
               if(d(i-1,j).GT.grnd) d(i-1,j)=grnd-.5
             end if
           end if
         end if
       end do
      end do		! no 1-node islands any more
      return
      end
